//---------------------------------------------------------------------------

#pragma hdrstop
#include <UCifraRC4.h>
#include <UCadenaExt.h>
#include <fstream>
using namespace std;

//---------------------------------------------------------------------------

#pragma argsused
char menu()
{
        char ch;
        cout << "(C)ifrar/(D)escifrar/(S)alir?: ";
        cin >> ch;
        cin.ignore(1000, '\n');
        switch(ch)
        {
                case 'C':
                        ch = 'c';
                        break;
                case 'D':
                        ch = 'd';
                        break;
                case 'S':
                        ch = 's';
                        break;
        }
        return ch;
}

void consigueCadena(CadenaExt& cad)
{
        clear(cad);
        cout << "Escriba la linea a interpretar: " << endl;
        getLine(cad, cin);
}

void consigueClave(CadenaExt& cad)
{
        clear(cad);
        cout << "Escriba la clave: " << endl;
        getLine(cad, cin);
}

bool invertir()
{
        char ch;
        cout << "Desea comprobar el resultado? s/n: ";
        cin >> ch;
        while(cin.get() != '\n');

        return ((ch == 's') || (ch == 'S'));
}

int main(int argc, char* argv[])
{
        CadenaExt ori, cif;
        CadenaExt* clave;
        CifraRC4* RC4;
        bool continua = true;
        RC4 = new CifraRC4;
        clave = new CadenaExt;
        init(*clave);
        init(*RC4);
        init(ori);
        init(cif);
        while(continua)
        {
                switch(menu())
                {
                        case 'c':
                                consigueCadena(ori);
                                consigueClave(*clave);
                                if(setClave(*RC4, *clave))
                                {
                                        setOperCfr(*RC4, cifrar);
                                        exeOperCfr(*RC4, ori, cif);
                                        cout << "Cadena cifrada: " << endl;
                                        putLine(cif, cout);
                                        if(invertir())
                                        {
                                                consigueClave(*clave);
                                                if(setClave(*RC4, *clave))
                                                {
                                                        setOperCfr(*RC4, descifrar);
                                                        exeOperCfr(*RC4, cif, ori);
                                                        cout << "Cadena original:" << endl;
                                                        putLine(ori, cout);
                                                }
                                        }
                                }
                                else
                                {
                                        cout << "Debe escribir una clave valida (Long mayor a cero)" << endl;
                                }
                                break;
                        case 'd':
                                consigueCadena(cif);
                                consigueClave(*clave);
                                if(setClave(*RC4, *clave))
                                {
                                        setOperCfr(*RC4, descifrar);
                                        exeOperCfr(*RC4, ori, cif);
                                        cout << "Cadena original: " << endl;
                                        putLine(ori, cout);
                                        if(invertir())
                                        {
                                                consigueClave(*clave);
                                                if(setClave(*RC4, *clave))
                                                {
                                                        setOperCfr(*RC4, cifrar);
                                                        exeOperCfr(*RC4, cif, ori);
                                                        cout << "Cadena cifrada: " << endl;
                                                        putLine(cif, cout);
                                                }
                                        }
                                }
                                else
                                {
                                        cout << "Debe escribir una clave valida (Long mayor a cero)" << endl;
                                }
                                break;
                        case 's':
                                continua = false;
                                break;
                }
        }
        free(*RC4);
        delete RC4;
        free(*clave);
        delete clave;
        free(ori);
        free(cif);
        return 0;
}
//---------------------------------------------------------------------------
