//--------8-------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "UCadenaExt.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)

void init(CadenaExt& Cad, tSize S)
{
        if(S == 0)
        {
                Cad.vector = NULL;
        }
        else
        {
                Cad.vector = new CharExt[S];
        }
        Cad.cont = 0;
        Cad.maxLC = S;
}

void free(CadenaExt& Cad)
{
        delete[] Cad.vector;
        Cad.vector = NULL;
        Cad.cont = 0;
        Cad.maxLC = 0;
}

void clear(CadenaExt& Cad)
{
        Cad.cont = 0;
}

void assign(CadenaExt& CadIzq, const CadenaExt& CadDer)
{
        if(&CadIzq.vector != &CadDer.vector)
        {
                clear(CadIzq);
                resize(CadIzq, size(CadDer));
                for(tSize i = 0; i < size(CadDer); i++)
                {
                        push_back(CadIzq, at(CadDer, i));
                }
        }
}

void resize(CadenaExt& Cad, tSize S)
{
        if(S <= 0)
        {
                free(Cad);
        }
        else
        {
                if(Cad.vector == NULL)
                {
                        init(Cad, S);
                }
                else
                {
                        if(max_size(Cad) != S)
                        {
                                CharExt* aux;
                                aux = new CharExt[S];
                                for(tSize i = 0; (i < S) && (i < size(Cad)); i++)
                                {
                                        aux[i] = Cad.vector[i];
                                }
                                delete[] Cad.vector;
                                Cad.vector = aux;
                                Cad.maxLC = S;
                                if(S < size(Cad))
                                {
                                        Cad.cont = S;
                                }
                        }
                }
        }
}

bool push_back(CadenaExt& Cad, CharExt C)
{
        if(max_size(Cad) == 0)
        {
                resize(Cad, 320);
        }
        if(size(Cad) == max_size(Cad))
        {
                resize(Cad, max_size(Cad) * 2);
        }
        Cad.vector[Cad.cont] = C;
        Cad.cont++;
        return true;
}

bool pop_back(CadenaExt& Cad)
{
        if(size(Cad) > 0)
        {
                Cad.cont--;
                Cad.vector[Cad.cont] = '\0';
                return true;
        }
        else return false;
}

CharExt at(const CadenaExt& Cad, tSize N)
{
        if(inrange(Cad, N))
        {
                return Cad.vector[N];
        }
        else throw exception();
}

CharExt& at(CadenaExt& Cad, tSize N)
{
        if(inrange(Cad, N))
        {
                return Cad.vector[N];
        }
        else throw exception();
}

bool replace(CadenaExt& Cad, tSize N, CharExt C)
{
        if(inrange(Cad, N))
        {
                at(Cad, N) = C;
                return true;
        }
        return false;
}

bool swap(CadenaExt& Cad, tSize N, tSize K)
{
        if(inrange(Cad, N) && inrange(Cad, K))
        {
                CharExt ch = at(Cad, N);
                replace(Cad, N, at(Cad, K));
                replace(Cad, K, ch);
                return true;
        }
        else return false;
}
void toCadenaExt(const char cstr[], CadenaExt& Cad)
{
        clear(Cad);
        for(tSize i = 0; cstr[i] != '\0'; i++)
        {
                push_back(Cad, cstr[i]);
        }
        resize(Cad, size(Cad));
}

bool getLine(CadenaExt& Cad, istream& Ent)
{
        char ch;
        clear(Cad);
        while(Ent.get(ch) && (ch != '\n')  && Ent.good())
        {
                push_back(Cad, CharExt(ch));
        }
        resize(Cad, size(Cad));

        return ((size(Cad) > 0) || Ent.good());
}

bool put(const CadenaExt& Cad, ostream& Sal)
{
        CharExt ch;
        tSize i = 0;
        while((i < size(Cad)) && Sal.put(at(Cad, i)))
        {
                i++;
        }
        return Sal;
}

