//---------------------------------------------------------------------------

#pragma hdrstop
#include <UCifraRC4.h>
#include <UCadenaExt.h>
#include <fstream>
using namespace std;

//---------------------------------------------------------------------------

#pragma argsused
char menu()
{
        char ch;
        cout << "(C)ifrar/(D)escifrar/(S)alir?: ";
        cin >> ch;
        cin.ignore(1000, '\n');
        switch(ch)
        {
                case 'C':
                        ch = 'c';
                        break;
                case 'D':
                        ch = 'd';
                        break;
                case 'S':
                        ch = 's';
                        break;
        }
        return ch;
}

void consigueCadena(CadenaExt& cad)
{
        cad.clear();
        cout << "Escriba la linea a interpretar: " << endl;
        getLine(cad, cin);
}

void consigueClave(CadenaExt& cad)
{
        cad.clear();
        cout << "Escriba la clave: " << endl;
        getLine(cad, cin);
}

bool invertir()
{
        char ch;
        cout << "Desea comprobar el resultado? s/n: ";
        cin >> ch;
        while(cin.get() != '\n');

        return ((ch == 's') || (ch == 'S'));
}

int main(int argc, char* argv[])
{
        CadenaExt ori, cif;
        CadenaExt* clave;
        CifraRC4* RC4;
        RC4 = new CifraRC4();
        clave = new CadenaExt();
        bool continua = true;
        while(continua)
        {
                switch(menu())
                {
                        case 'c':
                                consigueCadena(ori);
                                consigueClave(*clave);
                                if(RC4->setClave(*clave))
                                {
                                        RC4->setOperCfr(cifrar);
                                        RC4->exeOperCfr(ori, cif);
                                        cout << "Cadena cifrada: " << endl;
                                        putLine(cif, cout);
                                        if(invertir())
                                        {
                                                consigueClave(*clave);
                                                if(RC4->setClave(*clave))
                                                {
                                                        RC4->setOperCfr(descifrar);
                                                        RC4->exeOperCfr(cif, ori);
                                                        cout << "Cadena original:" << endl;
                                                        putLine(ori, cout);
                                                }
                                        }
                                }
                                else
                                {
                                        cout << "Debe escribir una clave valida (Long mayor a cero)" << endl;
                                }
                                break;
                        case 'd':
                                consigueCadena(cif);
                                consigueClave(*clave);
                                if(RC4->setClave(*clave))
                                {
                                        RC4->setOperCfr(descifrar);
                                        RC4->exeOperCfr(ori, cif);
                                        cout << "Cadena original: " << endl;
                                        putLine(ori, cout);
                                        if(invertir())
                                        {
                                                consigueClave(*clave);
                                                if(RC4->setClave(*clave))
                                                {
                                                        RC4->setOperCfr(cifrar);
                                                        RC4->exeOperCfr(cif, ori);
                                                        cout << "Cadena cifrada: " << endl;
                                                        putLine(cif, cout);
                                                }
                                        }
                                }
                                else
                                {
                                        cout << "Debe escribir una clave valida (Long mayor a cero)" << endl;
                                }
                                break;
                        case 's':
                                continua = false;
                                break;
                }
        }
        delete RC4;
        delete clave;

        return 0;
}
//---------------------------------------------------------------------------
