//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "UCifraRC4.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)

bool CifraRC4::init()
{
        cA = cB = 0;
        abc.resize(LonAlfa);
        funCfr = &CifraRC4::addCfr;
        return true;
}

void CifraRC4::free()
{
        cA = cB = 0;
}

bool CifraRC4::setClave(const CadenaExt& clave) // semilla
{
        inicial();

        if(clave.size() == 0)
        {
                return false;
        }
        else
        {
                this->clave = clave;
                for(cA = 0; cA < LonAlfa; cA++)
                {
                        cB = (cB + abc.at(cA) + this->clave.at(cA % this->clave.size())) % LonAlfa;
                        abc.swap(cA, cB);
                }
                return true;
        }
}

void CifraRC4::inicial() // alfabeto inicial de partida para generar la semilla
{
        abc.clear();
        abc.resize(LonAlfa);
        for(int i = 0; i < LonAlfa; i++)
        {
                abc.push_back(CharExt(i));
        }

        cA = cB = 0;
}

void CifraRC4::siguiente() // siguiente alfabeto para la generacin de la secuencia
{
        cA++;
        cA %= LonAlfa;
        cB += abc.at(cA);
        cB %= LonAlfa;
        abc.swap(cA, cB);
}

CharExt CifraRC4::genABC() // siguiente de la secuencia
{
        siguiente();

        return abc.at((abc.at(cA) + abc.at(cB)) % LonAlfa);
}

void CifraRC4::setOperCfr(opeCfr op)
{
        if(op == cifrar)
        {
                funCfr = &CifraRC4::addCfr;
        }
        else
        {
                funCfr = &CifraRC4::difCfr;
        }
}


CharExt CifraRC4::addCfr(CharExt a, CharExt b)
{
        return (a + b) % LonAlfa;
}

CharExt CifraRC4::difCfr(CharExt a, CharExt b)
{
        return (a + LonAlfa - b) % LonAlfa;
}

void CifraRC4::exeOperCfr(const CadenaExt& Ent, CadenaExt& Sal)
{
        CharExt e, r, s;
        Sal.clear();
        Sal.resize(Ent.size());
        for(tSize i = 0; i < Ent.size(); i++)
        {
                e = Ent.at(i);
                if(e >= LonCtrl)
                {
                        e -= LonCtrl;
                        r = genABC();
                        s = (*this.*funCfr)(e, r);
                        s += LonCtrl;
                }
                else
                {
                        s = e;
                }
                Sal.push_back(s);
        }
}

